package domExamples;

/**
 * 1. Import XML-related packages
 */
import org.w3c.dom.*;
import javax.xml.parsers.*;
import java.io.*;

/** From <a href="http://courses.coreservlets.com/Course-Materials/">the
 *  coreservlets.com tutorials on servlets, JSP, Struts, JSF, Ajax, GWT, and Java</a>.
 */

public class DomTest1 {
  public static void main(String[] args) {
    String file = "xmlFiles/test1.xml";
    if (args.length > 0) {
      file = args[0];
    }
    try {
      // 2. Create a DocumentBuilder
      DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
      DocumentBuilder builder = factory.newDocumentBuilder();
      
      // 3. Create a document from a file or stream
      Document document = builder.parse(new File(file));

      //4. Extract the root element
      Element root = document.getDocumentElement();
      System.out.println(root.getTagName());

      //5. Examine Attributes, getAttribute returns specific attribute
      //getAttributes() returns a Map (table) of names/values
      // Assuming that attribute nodes are known in advance
      System.out.printf("  name: %s%n",
                        root.getAttribute("name"));
      System.out.printf("  short name: %s%n",
                        root.getAttribute("shortName"));
      System.out.printf("  mission: %s%n",
                        root.getAttribute("mission"));
    } catch(Exception e) {
      e.printStackTrace();
    }
  }
}
